package com.fizz.business.constants.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

/**
 * 回退类型枚举
 *
 * @author chenhao
 * @date 2023/04/24
 */
@Getter
@AllArgsConstructor
public enum HalfReturnTypeEnum implements IEnum<String> {
    HEAD_COIL("头部卷"),
    TAIL_COIL("尾部卷")
    ;

    private final String desc;

    private static final Map<String, HalfReturnTypeEnum> MAP = new HashMap<>(5);

    static {
        for (HalfReturnTypeEnum e : HalfReturnTypeEnum.values()) {
            MAP.put(e.getValue(), e);
        }
    }

    @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
    public static HalfReturnTypeEnum getByValue(String value) {
        return MAP.get(value);
    }

    @JsonValue
    @Override
    public String getValue() {
        return this.name();
    }
}
